#include "fbeval.bas"
#include "monoinit.bas"

do
  optionen(1)
  if ende = 0 then spiel
loop until ende

function MIN(byval x as short, byval y as short) as short
  if x < y then return x else return y
end function
function MAX(byval x as short, byval y as short) as short
  if x < y then return y else return x
end function

function aktion(byval opt as ubyte = 0) as ubyte
  ' opt =0: Tasten liefern Funktionswert zurueck; =1: Tasten liefern ASCII-Wert
  '     +2: OK ist eingeblendet
  '     +4: ABBRUCH ist eingeblendet
  '     +8: - und + sind eingeblendet
  '    +16: JA und NEIN sind eingeblendet
  ' Rueckgabewert:
  '   32 -128: ASCII-Wert der gedrueckten Taste (opt=1; Sonderzeichen werden ignoriert!)
  '   0  -100: Nummer des Feldes (opt=0)
  '   201-210: Menue (Wurf, Handel, Kauf, Verkauf, Tausch, Bank, laden, speichen, neu, Optionen)
  '   249-255: Sonderbefehle (OK, minus, plus, ja, nein, Abbruch, Spielende)
  dim as integer mx, my, mb, m2x, m2y, m2b = 1
  dim taste as string
  do
    getmouse mx, my,, mb
    taste = inkey
    if mb = 2 then taste = chr(27)
    sleep 1
  loop until taste <> "" or mb = 1
  do while taste = "" and m2b <> 0
    getmouse m2x, m2y,, m2b
    taste = inkey
    sleep 1
  loop
  if taste = chr(255) & "k" then ende = -1 : exit function
  if opt and 1 then
    if (asc(taste)>31 and asc(taste)<129) then return taste[0]
    if asc(taste) = 13 then return 249
    if (opt and 2)=2 and (in(buttonfeld_ok,mx,my) and in(buttonfeld_ok,m2x,m2y)) then return 249
    return 0
  end if
  if taste <> "" then mx = -1
  if lcase(taste) = "w" or (in(Mwurf,mx,my) and in(Mwurf,m2x,m2y)) then return 201
  if lcase(taste) = "h" or (in(Mhandel,mx,my) and in(Mhandel,m2x,m2y)) then return 202
  if lcase(taste) = "k" or (in(Mkauf,mx,my) and in(Mkauf,m2x,m2y)) then return 203
  if lcase(taste) = "v" or (in(Mverkauf,mx,my) and in(Mverkauf,m2x,m2y)) then return 204

  if taste = "L" or (in(Mladen,mx,my) and in(Mladen,m2x,m2y)) then return 207
  if taste = "S" or (in(Mspeichern,mx,my) and in(Mspeichern,m2x,m2y)) then return 208
  if taste = "N" or (in(Mneu,mx,my) and in(Mneu,m2x,m2y)) then return 209
  if taste = "O" or (in(Moptionen,mx,my) and in(Moptionen,m2x,m2y)) then return 210
  if (opt and 6) = 2 and in(buttonfeld_ok,mx,my) and in(buttonfeld_ok,m2x,m2y) then return 249
  if (opt and 6) = 4 and in(buttonfeld_abbruch,mx,my) and in(buttonfeld_abbruch,m2x,m2y) then return 254
  if (opt and 6) = 6 then
    if in(buttonfeld_ok2,mx,my) and in(buttonfeld_ok2,m2x,m2y) then return 249
    if in(buttonfeld_abbruch2,mx,my) and in(buttonfeld_abbruch2,m2x,m2y) then return 254
  end if
  if opt and 8 then
    if taste = "-" or (in(buttonfeld_minus,mx,my) and in(buttonfeld_minus,m2x,m2y)) then return 250
    if taste = "+" or (in(buttonfeld_plus,mx,my) and in(buttonfeld_plus,m2x,m2y)) then return 251
  end if
  if opt and 16 then
    if lcase(taste) = "j" or lcase(taste) = "y" or _
      (in(buttonfeld_ja,mx,my) and in(buttonfeld_ja,m2x,m2y)) then return 252
    if lcase(taste) = "n" or (in(buttonfeld_nein,mx,my) and in(buttonfeld_nein,m2x,m2y)) then return 253
  end if
  if taste = chr(27) then return 254
  if taste = chr(13) then return 249
  if in(Gspielfeld, mx, my) then
    for i = 1 to AnzahlFelder
      if in(feld(i).position, mx, my) and in(feld(i).position, m2x, m2y) then return i
    next
  end if
  return 0
end function

sub bildladen(byval bildname as string, byref speicher as TypIcon)
  open "img/" & bildname for binary as #3
  dim as uinteger l = lof(3)
  close #3
  if l = 0 then
    kill "img/" & bildname
    speicher.grafik = imagecreate(1, 1)
    speicher.x = 1
    speicher.y = 1
  else
    open "img/" & bildname for input as #3
    get #3, 19, speicher.x
    get #3, 23, speicher.y
    close 3
    speicher.grafik = imagecreate(speicher.x, speicher.y)
    bload "img/" & bildname, speicher.grafik
  end if
end sub

sub computerEntschuldung(byref wer as TypSpieler)
  ' Hypotheken aufnehmen / Haeuser verkaufen, wenn Geld < 0
  while wer.geld < 0
    dim minimum as short = 2^14, minimalfeld as ubyte = 0, raus as ubyte = 0
    ' suche Feld zum Belasten
    for i as ubyte = 1 to AnzahlFelder
      if feld(i).besitzer <> wer.nr or (feld(i).status and 1) then continue for
      if mietberechnung(feld(i), 7) < minimum then
        ' wenn in der Gruppe hoehere Haeuserzahlen vorkommen, dann weitersuchen
        for k as ubyte = 0 to len(gruppe(feld(i).gruppe).grundstuecke)-1
          dim as ubyte temp = gruppe(feld(i).gruppe).grundstuecke[k]
          if feld(temp).besitzer <> wer.nr then continue for
          if feld(temp).haeuser > feld(i).haeuser then
            raus = 1 ' In der Gruppe gibt es noch Felder mit mehr Haeusern
            exit for
          end if
        next
        if raus = 1 then
          raus = 0
          continue for
        end if
        minimum = mietberechnung(feld(i), 7)
        minimalfeld = i
      end if
    next
    if minimalfeld = 0 then
      ' Spieler ist bankrott
      wer.vermoegen = -1
      for i as ubyte = 1 to AnzahlFelder
        if feld(i).besitzer = wer.nr then
          feld(i).status = 0
          feld(i).haeuser = 0
          feld(i).besitzer = 0
        end if
        zeichne i
      next
      wer.feld += 128
      zeichne wer.feld - 128
      info msg(MSG_aiBroke, wer.name), 4
      ausgeschieden += 1
      exit while
    else
      if feld(minimalfeld).haeuser > 0 then
        ' Haus verkaufen
        wer.geld += feld(minimalfeld).hauspreis\2
        wer.vermoegen -= feld(minimalfeld).hauspreis\2
        wer.belastbar -= feld(minimalfeld).hauspreis\2
        feld(minimalfeld).haeuser -= 1
        zeichne minimalfeld
        info msg(MSG_aiSell, feld(minimalfeld).name)
      else
        ' Hypothek aufnehmen
        wer.geld += feld(minimalfeld).preis\2
        wer.vermoegen -= feld(minimalfeld).preis\2
        wer.belastbar -= feld(minimalfeld).preis\2
        feld(minimalfeld).status += 1
        zeichne minimalfeld
        info msg(MSG_aiMortgage, feld(minimalfeld).name)
      end if
    end if
  wend
end sub

function computerFeldkauf(byref wer as TypSpieler, byref wo as TypFeld) as byte
  ' wuerde der Spieler das Feld kaufen?
  if wer.geld + wer.belastbar <= wo.preis then return 0 ' nicht ueber den Hypothekenrahmen kaufen
  dim as single wert = feldwert(wo, wer)
  if wer.geld > wo.preis*wert\3 then return -1         ' regulaere Entscheidung
  if wert < 1 then return -1                           ' besonders wertvolles Feld auch auf Pump
  return 0
end function

function computerFreikauf(byref wer as TypSpieler) as byte
  ' Moechte sich der Spieler aus dem Gefaengnis freikaufen?
  if wer.geld <= feld(Jail).preis then return 0
  if AIfeldzahl/AIrestfelder < 1.1 or AImietsumme/AnzahlFelder > AImietniveau/5 then return 0
  return -1
end function

function computerHandel(byval aktor as ubyte, byval partner as ubyte, byval geldbetrag as short) as ubyte
  ' Entscheidung des Computerspielers fuer oder gegen den Handel
  ' ret= 0: abschliessen; 1: unguenstiger Handel; 2: auf keinen Fall
  dim as integer wert1, wert2 ' Wertsteigerung fuer partner und fuer aktor
  ' berechne aktuellen Spielwert fuer partner und Spieler; tausche die Grundstuecke
  ' Je hoeher am Ende wert1 im Vergleich zu wert2 ist, desto besser ist der Tausch fuer partner.
  wert1 = - handel_wertberechnung(partner)
  wert2 = - handel_wertberechnung(aktor)
  for i as ubyte = 1 to AnzahlFelder
    if feld(i).status > 127 then
      if feld(i).besitzer=aktor then feld(i).besitzer=partner else feld(i).besitzer=aktor
    end if
  next
  ' berechne Spielwert von partner und Spieler nach dem Handel; tausche zurueck
  wert1 += handel_wertberechnung(partner)
  wert2 += handel_wertberechnung(aktor)
  for i as ubyte = 1 to AnzahlFelder
    if feld(i).status > 127 then
      if feld(i).besitzer=aktor then feld(i).besitzer=partner else feld(i).besitzer=aktor
    end if
  next

  if _DEBUG = 1 then
    info
    info "Handelswert fuer den Computerspieler: " & wert1 & "-" & wert2
    wert1 += geldbetrag - 1
    info "Gesamtwert: " & (wert1 - wert2)
    info " "
  end if

  ' Entscheidung gegen den Handel
  if wert1 < 0 or wert2-wert1 > AImietniveau\2  then return 2
  if wert1 < wert2 then return 1
  return 0
end function

sub computerKaufen(byval dran as ubyte)
  ' Computerspieler: Hypotheken tilgen, Haeuser bauen
  for i as ubyte = 1 to AnzahlFelder
    dim as ubyte besessen = 0
    if feld(i).besitzer <> dran then continue for
    if (feld(i).status and 1) and spieler(dran).geld-feld(i).preis*.55 > AImietniveau\2 then
      spieler(dran).geld -= feld(i).preis*.55
      spieler(dran).vermoegen += feld(i).preis\2
      spieler(dran).belastbar += feld(i).preis\2
      feld(i).status -= 1
      info msg(MSG_aiWipeOff, feld(i).name)
      zeichne i
    end if
    if feld(i).hauspreis = 0 or spieler(dran).geld-feld(i).hauspreis < AImietniveau then continue for
    if feld(i).haeuser = MaxHauszahl then continue for
    dim grupp as string = gruppe(feld(i).gruppe).grundstuecke, raus as ubyte = 0
    for k as ubyte = 0 to len(grupp) - 1
      if feld(grupp[k]).besitzer <> dran then continue for
      besessen += 1
      if (feld(grupp[k]).status and 1) then raus = 1
      if feld(grupp[k]).haeuser < feld(i).haeuser then raus = 1
    next
    if besessen < len(grupp) and besessen < gruppe(feld(i).gruppe).minbesitz then raus = 1
    if raus = 0 then
      spieler(dran).geld -= feld(i).hauspreis
      spieler(dran).vermoegen += feld(i).hauspreis
      spieler(dran).belastbar += feld(i).hauspreis\2
      feld(i).haeuser += 1
      info msg(MSG_aiBuy, feld(i).name)
      zeichne i
    end if
  next
end sub

sub entschuldung(byref wer as TypSpieler)
  dim as ubyte akt, wo
  info MSG_noMoney, 7
  if wer.geld + wer.belastbar < 0 then
    info MSG_withdraw, 7
    wo = wer.feld
    wer.feld = 0
    zeichne wo
    ausgeschieden += 1
    wer.vermoegen = -1
    for i=1 to AnzahlFelder
      if feld(i).besitzer = wer.nr then
        feld(i).haeuser = 0
        feld(i).status = 0
        feld(i).besitzer = 0
        zeichne i
      end if
    next
    dstring = wartetaste
  else
    info MSG_payDept1
    dstring = "\n" & msg(MSG_money, wer.geld & MSG_currency) & "\n"
    dstring = meldung(dstring & MSG_payDept2)
    do
      akt = aktion
      select case akt
      case 1 to AnzahlFelder
      feldinfo feld(akt)
      case 204
      verkaufen wer
      dstring = "\n" & msg(MSG_money, wer.geld & MSG_currency) & "\n"
      dstring = meldung(dstring & MSG_payDept2)
      end select
    loop until wer.geld >= 0
  end if
end sub

sub feldinfo(byval ort as TypFeld)
  dim as short rent, rent1, rent2, rentmerk
  dim as ubyte anz= len(gruppe(ort.gruppe).grundstuecke)
  dim as string text
  info
  info ort.farb_rgb, ort.name, 1
  if gruppe(ort.gruppe).name <> "" then info ort.farb_rgb, "(" & gruppe(ort.gruppe).name & ")", 1
  info " "

  if ort.einkommen > 0 then
    info msg(MSG_infoGo1, ort.einkommen & MSG_currency)
  elseif ort.einkommen < 0 then
    info msg(MSG_infoGo2, -ort.einkommen & MSG_currency)
  end if

  select case ort.art
  case 1
    info MSG_price & ":" & space(18-len(MSG_price)) & ort.preis & MSG_currency
    if ort.hauspreis <> 0 then
      info MSG_houseprice & ":" & space(18-len(MSG_houseprice)) & ort.hauspreis & MSG_currency
    end if
    info " "
    rent  = mietberechnung(ort, 2, 1, anz, 0)
    rent2 = rent
    for i as ubyte = 3 to 12
      rentmerk = mietberechnung(ort, i, 1, anz, 0)
      if rentmerk < rent then rent = rentmerk
      if rentmerk > rent2 then rent2 = rentmerk
    next
    if rent = rent2 then
      info MSG_rent & ":" & space(18-len(MSG_rent)) & rent & MSG_currency
    else
      info MSG_rent & ":" & space(18-len(MSG_rent)) & rent & MSG_currency & " - " & rent2 & MSG_currency
    end if
    for i=2 to anz
      rent1  = mietberechnung(ort, 2, i, anz, 0)
      rent2 = rent1
      for k as ubyte = 3 to 12
        rentmerk = mietberechnung(ort, k, i, anz, 0)
        if rentmerk < rent1 then rent1 = rentmerk
        if rentmerk > rent2 then rent2 = rentmerk
      next
      if rent <> rent1 then
        if rent1 = rent2 then
          text = rent1 & MSG_currency
          info i & " " & MSG_streets & ":" & space(15-len(MSG_streets)-(i<10)) & rent1 & MSG_currency
        else
          info i & " " & MSG_streets & ":" & space(15-len(MSG_streets)-(i<10)) _
                 & rent1 & MSG_currency & " - " & rent2 & MSG_currency
        end if
      end if
    next
    info " "
    if ort.hauspreis > 0 then
      for i=1 to MaxHauszahl
        rent1 = mietberechnung(ort, 2, anz, anz, i)
        rent2 = rent1
        for k as ubyte = 3 to 12
          rentmerk = mietberechnung(ort, k, anz, anz, i)
          if rentmerk < rent1 then rent1 = rentmerk
          if rentmerk > rent2 then rent2 = rentmerk
        next
        if rent1 = rent2 then
          info i & " " & MSG_houses & ":" & space(15-len(MSG_houses)-(i<10)) & rent1 & MSG_currency
        else
          info i & " " & MSG_houses & ":" & space(15-len(MSG_houses)) _
                 & rent1 & MSG_currency & " - " & rent2 & MSG_currency
        end if
      next
    end if
    if gruppe(ort.gruppe).minbesitz > 0 and gruppe(ort.gruppe).minbesitz < len(gruppe(ort.gruppe).grundstuecke) then
      info msg(MSG_minprop, str(gruppe(ort.gruppe).minbesitz))
    end if
  case 2
    info msg(MSG_drawCard, ort.gruppenname)
  case 3
    if ort.preis > 0 and ort.hauspreis = 0 then info msg(MSG_taxFixed, ort.preis & MSG_currency)
    if ort.preis = 0 and ort.hauspreis > 0 then info msg(MSG_taxPercent, ort.hauspreis & "%")
    if ort.preis > 0 and ort.hauspreis > 0 then
      info msg(MSG_taxMixed, ort.preis & MSG_currency, ort.hauspreis & "%")
    end if
    if ort.preis < 0 and ort.hauspreis = 0 then info msg(MSG_getFixed, -ort.preis & MSG_currency)
    if ort.preis = 0 and ort.hauspreis < 0 then info msg(MSG_getPercent, -ort.hauspreis & "%")
    if ort.preis < 0 and ort.hauspreis < 0 then
      info msg(MSG_getMixed, -ort.preis & MSG_currency, -ort.hauspreis & "%")
    end if
  end select
  if (ort.art and 4) and ort.sammelgeld = 0 then
    info " "
    info MSG_noCollect
  end if
  if ort.sammelgeld > 0 then
    info " "
    info msg(MSG_taxCollect, ort.sammelgeld & MSG_currency)
  end if
  if ort.sammelgeld < 0 then
    info " "
    info msg(MSG_getPay, -ort.sammelgeld & MSG_currency)
  end if
end sub

function feldwert(byref ort as TypFeld, byref wer as TypSpieler) as single
  ' Wieviel ist das Feld dem Spieler wert? (Je wertvoller, desto kleiner der Rueckgabewert)
  ' Bedeutung IN ETWA: wenn jedes Feld {Rueckgabewert}-mal von einem Gegner besucht wird, dann
  ' decken die Zusatzeinnahmen den Kaufpreis des Feldes
  dim as short unten = 0, oben = 0, merk = ort.besitzer
  dim as string grund = gruppe(ort.gruppe).grundstuecke
  dim as ubyte i, anz = 0, anz2 = len(grund)
  feld(ort.nr).besitzer = 0
  for i = 1 to anz2
    if feld(grund[i-1]).besitzer = wer.nr then anz += 1
  next
  for i = 1 to anz2
    if feld(grund[i-1]).besitzer = wer.nr then unten += mietberechnung(feld(grund[i-1]), 7, anz, anz2, 0)
  next
  feld(ort.nr).besitzer = wer.nr
  for i = 1 to len(grund)
    if feld(grund[i-1]).besitzer = wer.nr then oben += mietberechnung(feld(grund[i-1]), 7, anz+1, anz2, 0)
  next
  if anz = anz2 - 1 then oben += mietberechnung(feld(ort.nr), 7, anz2, anz2, MaxHauszahl)
  feld(ort.nr).besitzer = merk
  if oben = unten then oben = 1 : unten = 0
  return ort.preis / (oben-unten)
end function

sub geheum(byref wer as TypSpieler, byval wieviel as byte)
  dim as ubyte altfeld = wer.feld
  for i = 1 to abs(wieviel)
    wer.feld += sgn(wieviel)
    if wer.feld > AnzahlFelder then wer.feld = 1
    if wer.feld < 1 then wer.feld = AnzahlFelder
    if wieviel > 0 then
      if feld(wer.feld).einkommen > 0 then
        wer.geld += feld(wer.feld).einkommen
        info msg(MSG_passGo, feld(wer.feld).name)
        info msg(MSG_collectGo, feld(wer.feld).einkommen & MSG_currency)
        if feld(wer.feld).geldsammelpunkt > 0 then
          feld(feld(wer.feld).geldsammelpunkt).sammelgeld -= feld(wer.feld).einkommen
        end if
      end if
      if feld(wer.feld).einkommen < 0 then
        wer.geld += feld(wer.feld).einkommen
        info msg(MSG_passGo, feld(wer.feld).name)
        info msg(MSG_payGo, -feld(wer.feld).einkommen & MSG_currency)
        if feld(wer.feld).geldsammelpunkt > 0 then
          feld(feld(wer.feld).geldsammelpunkt).sammelgeld -= feld(wer.feld).einkommen
        end if
      end if
    end if
  next
  zeichne altfeld
  zeichne wer.feld
  info MSG_reachField
  info feld(wer.feld).farb_rgb, feld(wer.feld).name, 5
  if feld(wer.feld).art = 255 then info MSG_justVisit, 1
  if feld(wer.feld).sammelgeld > 0 then
    info msg(MSG_collectField, feld(wer.feld).sammelgeld & MSG_currency)
    wer.geld += feld(wer.feld).sammelgeld
    feld(wer.feld).sammelgeld = 0
  end if
  if feld(wer.feld).gehezu <> 0 then gehezu(wer, feld(wer.feld).gehezu)
end sub

sub gehezu(byref wer as TypSpieler, byval wohin as ubyte)
  if wohin = 255 then
    dim as ubyte altfeld = wer.feld
    wer.feld = 255
    zeichne altfeld
    pasch = 0
  elseif wohin < wer.feld then
    geheum(wer, wohin+AnzahlFelder-wer.feld)
  else
    geheum(wer, wohin-wer.feld)
  end if
end sub

sub gehezugruppe(byref wer as TypSpieler, byval wohin as string)
  i = wer.feld
  do
    i += 1
    if i > AnzahlFelder then i = 1
  loop until gruppe(feld(i).gruppe).name = wohin or i = wer.feld
  if i <> wer.feld then gehezu(wer, i)
end sub

sub gesamtinfo
  line (Gueberblick.x, Gueberblick.y)-step(Gueberblick.b, Gueberblick.h), 0, BF
  dim as string ziel
  select case spielziel
    case 0    : ziel = MSG_optAim1
    case 1    : ziel = msg(MSG_optAim2, 3*spielgeld & MSG_currency)
    case 2    : ziel = msg(MSG_optAim2, 5*spielgeld & MSG_currency)
    case else : ziel = msg(MSG_rounds, str(Rundenzahl))
  end select
  draw string (Gueberblick.x+Gueberblick.b\2-len(ziel)*4, Gueberblick.y), ziel
  draw string (Gueberblick.x, Gueberblick.y+30), MSG_name
  draw string (Gueberblick.x+178-len(MSG_cash)*8, Gueberblick.y+30), MSG_cash
  draw string (Gueberblick.x+278-len(MSG_capital)*8, Gueberblick.y+30), MSG_capital
  dim as ubyte k = 0
  for i = 1 to 20
    if spieler(i).typ = 0 then continue for
    k += 1
    draw string (Gueberblick.x, Gueberblick.y+k*12+50), spieler(i).name, spieler(i).farbe
    dstring = spieler(i).geld & MSG_currency
    if spieler(i).vermoegen < 0 then dstring = "-----"
    draw string (Gueberblick.x+178-len(dstring)*8, Gueberblick.y+k*12+50), dstring
    if spieler(i).vermoegen >= 0 then dstring = (spieler(i).geld + spieler(i).vermoegen) & MSG_currency
    draw string (Gueberblick.x+278-len(dstring)*8, Gueberblick.y+k*12+50), dstring
  next
end sub

sub handel(byref wer as TypSpieler)
  dim as ubyte akt, partner=0, felder1=0, felder2=0
  dim as short geldbetrag = 0, maxbetrag = 0
  mark Mhandel
  info
  info MSG_trade, 7
  info MSG_tradeInstruction
  info MSG_tradeOk, 4
  info MSG_tradeMoney
  put (buttonfeld_plus.x, buttonfeld_plus.y), button_plus.grafik, pset
  put (buttonfeld_minus.x, buttonfeld_minus.y), button_minus.grafik, pset
  put (buttonfeld_ok2.x, buttonfeld_ok2.y), button_ok.grafik, pset
  put (buttonfeld_abbruch2.x, buttonfeld_abbruch2.y), button_abbruch.grafik, pset
  textausgabe buttonfeld_wert, geldbetrag & MSG_currency

  do
    akt = aktion(14)
    if akt > 0 and akt <= AnzahlFelder then
      if partner > 0 and feld(akt).besitzer<>partner and feld(akt).besitzer<>wer.nr then continue do
      if feld(akt).besitzer = 0 or feld(akt).haeuser > 0 then continue do
      if feld(akt).besitzer = wer.nr then
        mark feld(akt).position, &hffffff
        felder1 += (feld(akt).status > 127)*2 + 1
        feld(akt).status xor= 128
      else
        mark feld(akt).position, &hffffff
        felder2 += (feld(akt).status > 127)*2 + 1
        feld(akt).status xor= 128
        if felder2 = 0 then
          partner = 0
          maxbetrag = 0
          if geldbetrag < -maxbetrag then
            geldbetrag = -maxbetrag + (maxbetrag mod curunit)
            textausgabe buttonfeld_wert, geldbetrag & MSG_currency
          end if
        else
          partner = feld(akt).besitzer
          maxbetrag = spieler(partner).geld
          if geldbetrag < -maxbetrag then
            geldbetrag = -maxbetrag + (maxbetrag mod curunit)
            textausgabe buttonfeld_wert, geldbetrag & MSG_currency
          end if
       end if
      end if
    end if
    if akt = 250 and geldbetrag > -maxbetrag then
      geldbetrag -= curunit
      textausgabe buttonfeld_wert, geldbetrag & MSG_currency
    end if
    if akt = 251 and geldbetrag <= wer.geld - curunit then
      geldbetrag += curunit
      textausgabe buttonfeld_wert, geldbetrag & MSG_currency
    end if
    if ende then exit sub
  loop until (akt = 249 and partner <> 0) or akt = 254 or akt = 202
  ' Entscheidung des Computerspielers fuer oder gegen den Handel
  if akt=249 then
    if spieler(partner).typ <> 1 then
      dbyte = computerHandel(wer.nr, partner, geldbetrag)
      if dbyte = 2 then
        info msg(MSG_tradeNoDeal, spieler(partner).name), 4
        akt = 254
      elseif dbyte = 1 then
        info msg(MSG_tradeBadDeal, spieler(partner).name), 4
        akt = 254
      else
        info msg(MSG_tradeMakeDeal, spieler(partner).name), 4
      end if
      textausgabe buttonfeld_ok2, ""
      textausgabe buttonfeld_abbruch2, ""
      dstring = wartetaste
    end if
  end if
  if akt=249 then
    wer.geld -= geldbetrag
    spieler(partner).geld += geldbetrag
  end if
  for i as ubyte = 1 to AnzahlFelder
    if feld(i).status > 127 then
      feld(i).status -= 128
      mark feld(i).position, &hffffff
      if akt = 249 then
        if (feld(i).status and 1) = 0 then spieler(feld(i).besitzer).belastbar -= feld(i).preis\2
        if feld(i).besitzer=wer.nr then feld(i).besitzer=partner else feld(i).besitzer=wer.nr
        if (feld(i).status and 1) = 0 then spieler(feld(i).besitzer).belastbar += feld(i).preis\2
        zeichne i
      end if
    end if
  next
  mark Mhandel
  spielerinfo wer
end sub

function handel_wertberechnung(spielernr as ubyte) as integer
  dim as integer ret = 0, grupp1, grupp2
  for i as ubyte = 1 to AnzahlFelder
    if feld(i).besitzer = spielernr then
      if feld(i).status and 1 then
        ret += feld(i).preis*.5
      else
        ret += feld(i).preis
      end if
      grupp1 = len(gruppe(feld(i).gruppe).grundstuecke)
      grupp2 = 0
      for k = 0 to grupp1 - 1
        if feld(gruppe(feld(i).gruppe).grundstuecke[k]).besitzer = spielernr then grupp2 += 1
      next
      ret += mietberechnung(feld(i), 7)*3
      ret += mietberechnung(feld(i), 7, grupp1, grupp1, MaxHauszahl) \ 2^(grupp1 - grupp2 + 1)
    end if
  next
  return ret
end function

function in(byval feld as TypGrafikfeld, byval x as ushort, byval y as ushort) as ubyte
  locate 1,1
  if x>feld.x and x<feld.x+feld.b and y>feld.y and y<feld.y+feld.h then return 1
  return 0
end function

sub info(byval farbe as uinteger = &hffffff, byval ausgabe as string, byval opt as ubyte = 0)
  ' Schreibt eine Zeile in Ginfo. Die Zeilennummer wird durch Infozeile festgelegt.
  ' opt = 0:normal; +1:zentriert; +2:fett; +4:Absatz
  ' ausgabe = "" loescht das Infofeld und steuert Zeile opt an.
  dim as ubyte x, maxlen=31 ' x: Einrueckung rel. zu Ginfo; maxlen: max. Zeilenlaenge
  dim l as byte, text as string = ausgabe, temp as any ptr
  if len(text) > maxlen then
    for l = maxlen+1 to 1 step -1
      if mid(text, l, 1) = " " then
        if opt and 4 then Infozeile += 1
        info farbe, left(text, l-1), (opt and 3)
        info farbe, mid(text, l+1), (opt and 3)
        if opt and 4 then Infozeile += 1
        exit sub
      end if
    next
  end if
  with Ginfo
    if text = "" then text="[FEHLENDE MELDUNG]"
    if text="\n" then
      line (.x+1, .y+1)-step (.b-2, .h-2), 0, BF
      Infozeile = opt
    else
      Infozeile += 1
      if opt and 4 then Infozeile +=1
      'if Infozeile = Ginfo.h\13 - 4 then textausgabe buttonfeld_ok, ""
      do while Infozeile > .h\13 - 2
        sleep 500
        temp = imagecreate(.b-4, .h-15)
        get (.x+2, .y+15)-step(.b-5, .h-16), temp
        put (.x+2, .y+2), temp, pset
        imagedestroy temp
        Infozeile -= 1
      loop
      if opt and 1 then x = .b/2 - 4*len(text) else x = 10
      draw string (.x+x, .y+Infozeile*13+5), text, farbe
      if opt and 2 then draw string (.x+x+1, .y+Infozeile*13+5), text, farbe
      if opt and 4 then Infozeile +=1
    end if
  end with
end sub
sub info(byval t as string = "\n", byval o as ubyte = 0)
  info(&hffffff, t, o)
end sub

function janein as ubyte
  put (buttonfeld_ja.x, buttonfeld_ja.y), button_ja.grafik, pset
  put (buttonfeld_nein.x, buttonfeld_nein.y), button_nein.grafik, pset
  dim akt as ubyte
  do
    akt = aktion(16)
    if akt = 255 then ende = -1
  loop until akt = 252 or akt = 253 or akt = 254 or ende
  textausgabe buttonfeld_ja, ""
  textausgabe buttonfeld_nein, ""
  if akt = 252 then return 1 else return 0
end function

sub kaufen(byref wer as TypSpieler)
  dim akt as ubyte, minhaus as byte, besessen as ubyte, grup as TypGruppe
  mark Mkauf
  do
    info
    info msg(MSG_money, wer.geld & MSG_currency)
    info MSG_clickToBuy
    info MSG_pressESC
    put (buttonfeld_abbruch.x, buttonfeld_abbruch.y), button_abbruch.grafik, pset
    do
      akt = aktion(4)
      minhaus = 99
      if akt > 0 and akt <= AnzahlFelder then
        if feld(akt).besitzer = wer.nr then
          grup = gruppe(feld(akt).gruppe)
          if feld(akt).hauspreis = 0 or feld(akt).haeuser = MaxHauszahl then
            minhaus = -1
          else
            besessen = len(grup.grundstuecke)
            for i=1 to len(grup.grundstuecke)
              with feld(asc(mid(grup.grundstuecke, i, 1)))
              if .status = 1 and .besitzer = wer.nr then minhaus = -1: exit for
              if .besitzer = wer.nr then
                minhaus = MIN(.haeuser, minhaus)
              else
                besessen -= 1
              end if
              end with
            next
            if besessen < len(grup.grundstuecke) and besessen < grup.minbesitz then minhaus = -1
          end if
          if feld(akt).haeuser = minhaus and feld(akt).hauspreis <= wer.geld then
            wer.geld -= feld(akt).hauspreis
            wer.vermoegen += feld(akt).hauspreis
            wer.belastbar += feld(akt).hauspreis/2
            feld(akt).haeuser += 1
            zeichne akt
            gesamtinfo
          elseif feld(akt).status = 1 and feld(akt).preis*.55 <= wer.geld then
            wer.geld -= feld(akt).preis*.55
            wer.vermoegen += feld(akt).preis/2
            wer.belastbar += feld(akt).preis/2
            feld(akt).status = 0
            zeichne akt
            gesamtinfo
          end if
        end if
      end if
    loop until akt > 0 or ende
  loop until akt = 203 or akt = 254 or ende
  mark Mkauf
  textausgabe buttonfeld_abbruch, ""
  spielerinfo wer
end sub

sub mark (byval ort as TypGrafikfeld, byval farbe as uinteger = &hffffff)
  dim img as any pointer
  img = imagecreate(ort.b-2, ort.h-2, farbe)
  put (ort.x+1, ort.y+1), img, xor
  imagedestroy img
end sub

function meldung(byval originaltext as string = "", byval eingabe as string = "") as string
  ' Gibt eine Meldung aus und wartet auf einen Tastendruck. Rueckgabe: gedrueckte Taste
  ' eingabe = "*":beliebige Taste; "":keine Tastatureingabe erwartet
  dim ret as string = "", text as string = originaltext, neuezeile as ushort
  i = 0
  with Gnachricht
  line (.x+1, .y+1)-step(.b-2, .h-2), 0, BF
  do
    i += 1
    neuezeile = instr(text, "\n")
    if neuezeile then
      if neuezeile > 1 then draw string (.x+10, .y+i*13-10), left(text, neuezeile-1)
      text = mid(text, neuezeile+2)
    else
      draw string (.x+10, .y+i*13-10), text
      exit do
    end if
  loop until i>4
  if eingabe <> "" then
    do
      ret = input(1)
    loop until eingabe="*" or instr(eingabe, ret)
  end if
  end with
  return ret
end function

function mietberechnung(byval ort as TypFeld, byval wurf as TypWurf) as short
  ' berechne aktuelle Miete des Feldes
  return mietberechnung(ort, wurf.w1 + wurf.w2)
end function

function mietberechnung(byval ort as TypFeld, byval wurf as ubyte) as short
  ' berechne aktuelle Miete des Feldes
  dim grup as TypGruppe = gruppe(ort.gruppe), anz as ubyte
  for i=1 to len(grup.grundstuecke)
    if feld(asc(mid(grup.grundstuecke, i, 1))).besitzer = ort.besitzer then anz += 1
  next
  return mietberechnung(ort, wurf, anz, len(grup.grundstuecke), ort.haeuser)
end function

function mietberechnung(byval ort as TypFeld, byval wurf as ubyte, byval anz as ubyte, byval anz2 as ubyte, byval haus as ubyte) as short
  ' berechne Miete, wenn der Besitzer anz Gruppenfelder besitzt und haus Haeuser errichtet hat
  ' anz2 ist die Gesamtzahl der Grundstuecke, die zu dieser Gruppe gehoeren
  dim position as ubyte, rent as string = ort.rentmath
  if rent = "" then
    if haus = 0 and anz2 = anz then
      return ort.miete(0)*2
    else
      return ort.miete(haus)
    end if
  else
    do while instr(rent, "$")
      mid(rent, instr(rent, "$")) = " "
    loop
    do
      position = instr(ucase(rent), "{GROUPOWNED}")
      if position = 0 then exit do
      rent = left(rent, position-1) & anz & mid(rent, position+12)
    loop
    do
      position = instr(ucase(rent), "{HOUSES}")
      if position = 0 then exit do
      rent = left(rent, position-1) & haus & mid(rent, position+8)
    loop
    do
      position = instr(ucase(rent), "{DICE}")
      if position = 0 then exit do
      rent = left(rent, position-1) & wurf & mid(rent, position+6)
    loop
    return Eval.Execute(rent).Value
  end if
end function

function msg(byval text as string, byval var1 as string, byval var2 as string = "", byval var3 as string = "") as string
  ' ersetzt in text die Ausdruecke %var1%, %var2% und %var3%
  dim ret as string = text, such as ushort
  such = instr(lcase(ret), "%var1%")
  if such > 0 then ret = left(ret, such-1) & var1 & mid(ret, such+6)
  if var2 <> "" then
    such = instr(lcase(ret), "%var2%")
    if such > 0 then ret = left(ret, such-1) & var2 & mid(ret, such+6)
  end if
  if var3 <> "" then
    such = instr(lcase(ret), "%var3%")
    if such > 0 then ret = left(ret, such-1) & var3 & mid(ret, such+6)
  end if
  return ret
end function

function pruefeSpielende(byval opt as ubyte = 0, byval dran as ubyte = 0) as byte
  if spielziel > 2 and Rundenzahl = 0 then return -1
  if opt = 1 then
    if dran = Startspieler and Rundenzahl > 0 then
      Rundenzahl -= 1
      if Rundenzahl = 0 then return -1
    end if
  end if
  if spielziel = 1 then
    for i = 1 to 20
      if spieler(i).vermoegen + spieler(i).geld >= spielgeld*3 then return -1
    next
  elseif spielziel = 2 then
    for i = 1 to 20
      if spieler(i).vermoegen + spieler(i).geld >= spielgeld*5 then return -1
    next
  end if
  return 0
end function

sub spiel
  ausgeschieden = 0
  do
    Startspieler = int(rnd*20)+1
    sleep 1
    if inkey = chr(255) & "k" then ende = -1 : exit sub
  loop until spieler(Startspieler).typ > 0
  Rundenzahl = 0
  dim as ubyte akt, akt2, weiter, temp
  dim as ubyte dran = Startspieler
  dim miet as ushort, maxkredit as uinteger = 0, newrent as string
  dim wurf as TypWurf, text as string, aktuellfeld as TypFeld, aktuellkarte as TypKarte
  for i=1 to 20
    spieler(i).feld = spielstart
    spieler(i).geld = spielgeld
    spieler(i).vermoegen = 0
    spieler(i).nr = i
  next
  if spielziel = 3 then Rundenzahl = 100
  if spielziel = 4 then Rundenzahl = 200
  zeichne spielstart
  pasch = 0

  do
    dstring = meldung()
    weiter = 0
    if dran > 20 then dran = 1
    do while spieler(dran).typ = 0 or spieler(dran).vermoegen < 0
      dran = dran mod 20 + 1
      if pruefeSpielende(1, dran) then weiter = 1
    loop
    if weiter = 1 then exit do
    weiter = 0
    if ausgeschieden = AnzahlSpieler - 1 then
      info msg(MSG_win, spieler(dran).name), 7
      exit do
    end if
    gesamtinfo
    spielerinfo(spieler(dran))

    if spieler(dran).typ > 1 then

      ' COMPUTERSPIELER
      ' aktuelle Mietpreise und Feldkosten berechnen
      AImietsumme = 0
      AIrestfelder = 0
      AIrestpreissumme = 0
      for i as ubyte = 1 to AnzahlFelder
        if feld(i).besitzer = 0 then
          AIrestfelder += 0
          AIrestpreissumme += feld(i).preis
          continue for
        end if
        if feld(i).besitzer <> dran and (feld(i).status and 1) = 0 then
          AImietsumme += mietberechnung(feld(i), 7)
        end if
      next
      computerKaufen(dran)
      ' Spieler ist im Gefaengnis
      if spieler(dran).feld > 252 and computerFreikauf(spieler(dran)) = -1 then
        info msg(MSG_payJail2, feld(Jail).preis & MSG_currency, gefaengnis)
        spieler(dran).geld -= feld(Jail).preis
        spieler(dran).feld = Jail
        zeichne Jail
        gesamtinfo
      end if
      wurf = spielerwurf(spieler(dran))
      do
        gesamtinfo
        weiter = 1
        aktuellfeld = feld(spieler(dran).feld)
        if aktuellfeld.besitzer = 0 and aktuellfeld.art=1 then
          info MSG_forSale
          if computerFeldkauf(spieler(dran), aktuellfeld) then
            info msg(MSG_buy, spieler(dran).name, aktuellfeld.name, aktuellfeld.preis & MSG_currency)
            spieler(dran).geld -= aktuellfeld.preis
            spieler(dran).vermoegen += aktuellfeld.preis
            spieler(dran).belastbar += aktuellfeld.preis\2
            feld(spieler(dran).feld).besitzer = dran
            zeichne spieler(dran).feld
          else
            info msg(MSG_notBuy, spieler(dran).name, aktuellfeld.name)
          end if
        elseif aktuellfeld.art=2 then
          newrent = spiel_karteziehen(spieler(dran))
          if aktuellfeld.nr <> spieler(dran).feld and spieler(dran).feld < 253 then
            weiter = 0
            aktuellfeld = feld(spieler(dran).feld)
            sleep 2000
          end if
        elseif aktuellfeld.art=3 then
          spiel_steuernzahlen spieler(dran)
          if aktuellfeld.nr <> spieler(dran).feld and spieler(dran).feld < 253 then
            weiter = 0
            aktuellfeld = feld(spieler(dran).feld)
            sleep 2000
          end if
        elseif aktuellfeld.besitzer <> spieler(dran).nr then
          if aktuellfeld.status = 0 then
            if newrent <> "" then swap newrent, aktuellfeld.rentmath
            miet = mietberechnung(aktuellfeld, wurf)
            if newrent <> "" then aktuellfeld.rentmath = newrent
            newrent = ""
            if miet > 0 then
              info msg(MSG_payRent, spieler(dran).name, spieler(aktuellfeld.besitzer).name, _
                       miet & MSG_currency)
              spieler(dran).geld -= miet
              spieler(aktuellfeld.besitzer).geld += miet
            end if
          else
            info msg(MSG_noRent, spieler(dran).name)
          end if
        end if
      loop until weiter = 1
      computerEntschuldung(spieler(dran))
      gesamtinfo
      dstring = wartetaste

    else

      ' MENSCHLICHER SPIELER
      do
        gesamtinfo
        akt = aktion
        select case akt
        case 201
          mark Mwurf
          if spieler(dran).feld > 252 then
            ' Spieler ist im Gefaengnis
            dstring = meldung(msg(MSG_payJail1, feld(Jail).preis & MSG_currency))
            if janein = 1 then
              info msg(MSG_payJail2, feld(Jail).preis & MSG_currency, gefaengnis)
              spieler(dran).geld -= feld(Jail).preis
              spieler(dran).feld = Jail
              zeichne Jail
              gesamtinfo
            end if
            dstring = meldung
            if ende then exit sub
          end if
          wurf = spielerwurf(spieler(dran))
          mark Mwurf, &hAAAAAA
          aktuellfeld = feld(spieler(dran).feld)
          do
            weiter = 1
            if aktuellfeld.besitzer = 0 and aktuellfeld.art=1 then
              info MSG_forSale
              dstring = msg("\n" & MSG_money & "\n", spieler(dran).geld & MSG_currency)
              dstring &= msg(MSG_askBuy, aktuellfeld.name, aktuellfeld.preis & MSG_currency)
              dstring = meldung(dstring)
              put (buttonfeld_ja.x, buttonfeld_ja.y), button_ja.grafik, pset
              put (buttonfeld_nein.x, buttonfeld_nein.y), button_nein.grafik, pset
              do
                akt2 = aktion(16)
                if ende then exit sub
                select case akt2
                case 1 to AnzahlFelder
                  feldinfo feld(akt2)
                case 204
                  if spieler(dran).geld < aktuellfeld.preis then
                    verkaufen spieler(dran), aktuellfeld.preis
                    dstring = msg("\n" & MSG_money & "\n", spieler(dran).geld & MSG_currency)
                    dstring &= msg(MSG_askBuy, aktuellfeld.name, aktuellfeld.preis & MSG_currency)
                    dstring = meldung(dstring)
                    put (buttonfeld_ja.x, buttonfeld_ja.y), button_ja.grafik, pset
                    put (buttonfeld_nein.x, buttonfeld_nein.y), button_nein.grafik, pset
                  end if
                case 252
                  if spieler(dran).geld >= aktuellfeld.preis then
                    spieler(dran).geld -= aktuellfeld.preis
                    spieler(dran).vermoegen += aktuellfeld.preis
                    spieler(dran).belastbar += aktuellfeld.preis/2
                    feld(spieler(dran).feld).besitzer = dran
                    zeichne spieler(dran).feld
                    exit do
                  end if
                end select
              loop until akt2 = 253
            elseif aktuellfeld.besitzer <> dran and aktuellfeld.art=1 then
              if aktuellfeld.status = 0 then
                if newrent <> "" then swap newrent, aktuellfeld.rentmath
                miet = mietberechnung(aktuellfeld, wurf)
                if newrent <> "" then aktuellfeld.rentmath = newrent
                newrent = ""
                info msg(MSG_payRent, spieler(dran).name, spieler(aktuellfeld.besitzer).name, _
                         miet & MSG_currency)
                spieler(dran).geld -= miet
                spieler(aktuellfeld.besitzer).geld += miet
                if spieler(dran).geld >= 0 then
                  gesamtinfo
                  dstring = wartetaste
                else
                  sleep 2000
                end if
              else
                info msg(MSG_noRent, spieler(dran).name)
                gesamtinfo
                dstring = wartetaste
              end if
            elseif aktuellfeld.art=2 then
              newrent = spiel_karteziehen(spieler(dran))
              if spieler(dran).geld >= 0 and (spieler(dran).feld = aktuellfeld.nr _
                or spieler(dran).feld < 253) then
                gesamtinfo
                dstring = wartetaste
              else
                sleep 2000
              end if
              if aktuellfeld.nr <> spieler(dran).feld and spieler(dran).feld < 253 then weiter = 0
              aktuellfeld = feld(spieler(dran).feld)
            elseif aktuellfeld.art=3 then
              spiel_steuernzahlen spieler(dran)
              if spieler(dran).geld >= 0 then
                gesamtinfo
                dstring = wartetaste
              else
                sleep 2000
              end if
            else
              gesamtinfo
              dstring = wartetaste
            end if
          loop until weiter = 1
          mark Mwurf, &h555555
          if spieler(dran).geld < 0 then entschuldung spieler(dran)
        case 202
          handel spieler(dran)
        case 203
          kaufen spieler(dran)
        case 204
          verkaufen spieler(dran)
        case 209
          dstring = meldung(MSG_askNewGame)
          if janein = 1 then exit sub
          dstring = meldung
        case 210
          optionen 2
          spielerinfo spieler(dran)
        case 254
          spielerinfo spieler(dran)
        case 1 to AnzahlFelder
          feldinfo feld(akt)
        end select
      loop until weiter = 1 or ende
    end if
    if wurf.w1 = wurf.w2 and spieler(dran).feld < 252 then
      if pruefeSpielende then exit do
    else
      dran += 1
      if pruefeSpielende(1, dran) then exit do
    end if

  loop until pruefeSpielende or ende
  if ende = 0 then
    info MSG_gameOver, 7
    dstring = wartetaste
  end if
end sub

function spiel_karteziehen(byref wer as TypSpieler) as string
  dim as TypFeld aktuellfeld = feld(wer.feld)
  dbyte = aktuellfeld.gruppe
  kartenstapel(dbyte).position += 1
  if kartenstapel(dbyte).position > AnzahlKarten(dbyte) then kartenstapel(dbyte).position = 1
  dim as TypKarte aktuellkarte = karte(dbyte, kartenstapel(dbyte).position)
  dim as short zuzahlen
  info aktuellkarte.name, 4
  zuzahlen += aktuellkarte.zahle
  if zuzahlen > 0 then feld(aktuellfeld.geldsammelpunkt).sammelgeld += zuzahlen
  for i=1 to 20
    if spieler(i).vermoegen >= 0 and spieler(i).typ > 0 and i <> wer.nr then
      spieler(i).geld += aktuellkarte.zahleallen
      zuzahlen += aktuellkarte.zahleallen
    end if
  next
  for i=1 to AnzahlFelder
    if feld(i).art = 1 and feld(i).besitzer = wer.nr then
      if feld(i).haeuser = MaxHauszahl then
        zuzahlen += aktuellkarte.zahlehotel
      else
        zuzahlen += aktuellkarte.zahlehaus*feld(i).haeuser
      end if
    end if
  next
  wer.geld -= zuzahlen
  if zuzahlen > 0 then
    info msg(MSG_payCard, zuzahlen & MSG_currency)
  elseif zuzahlen < 0 then
    info msg(MSG_collectCard, (-zuzahlen) & MSG_currency)
  end if
  if aktuellkarte.gehe <> 0 then geheum wer, aktuellkarte.gehe
  if aktuellkarte.gehezufeld <> 0 then gehezu wer, aktuellkarte.gehezufeld
  if aktuellkarte.gehezugruppe <> "" then gehezugruppe wer, aktuellkarte.gehezugruppe
  return aktuellkarte.rentmath
  ' to do: OutOfJail, CanBeOwned
end function

sub spiel_steuernzahlen(byref wer as TypSpieler)
  dim aktuellfeld as TypFeld = feld(wer.feld), steuer as short
  if aktuellfeld.preis = 0 then
    steuer = aktuellfeld.hauspreis/100*(wer.geld+wer.vermoegen)
  elseif aktuellfeld.hauspreis = 0 then
    steuer = aktuellfeld.preis
  else
    steuer = MIN(aktuellfeld.preis, aktuellfeld.hauspreis/100*(wer.geld+wer.vermoegen))
  end if
  if steuer > 0 then
    info msg(MSG_taxFixed, steuer & MSG_currency)
  elseif steuer < 0 then
    info msg(MSG_getFixed, -steuer & MSG_currency)
  end if
  wer.geld -= steuer
  feld(aktuellfeld.geldsammelpunkt).sammelgeld += steuer
end sub

function spielerwurf(byref wer as TypSpieler) as TypWurf
  dim wurf as TypWurf, altfeld as ubyte
  info
  info wer.farbe, msg(MSG_turn, wer.name), 1
  Infozeile = 9
  wurf = werfen
  text = msg(MSG_score, str(wurf.w1+wurf.w2))
  if wurf.w1 = wurf.w2 then text &= " " & MSG_double
  info text
  if wurf.w1 = wurf.w2 and pasch > 1 and Jail <> 0 then
    wer.feld += 100
    zeichne wer.feld - 100
    wer.feld = 255
    info msg(MSG_threeDoubles, gefaengnis), 4
    pasch = 0
    exit function
  end if
  if wer.feld < 253 then
    geheum(wer, wurf.w1+wurf.w2)
  else
    wer.feld -= 1
  end if
  if wurf.w1 = wurf.w2 then
    if wer.feld>251 then
      info msg(MSG_outOfJail, gefaengnis)
      wer.feld = Jail
      zeichne Jail
      pasch = -1
    else
      info msg(MSG_onceAgain, wer.name)
      pasch += 1
    end if
  else
    pasch = 0
    if wer.feld = 252 then
      info msg(MSG_payJail2, feld(Jail).preis & MSG_currency, gefaengnis)
      wer.geld -= feld(Jail).preis
      wer.feld = Jail
      zeichne Jail
      gesamtinfo
      sleep 2000
      geheum(wer, wurf.w1+wurf.w2)
    end if
  end if
  return wurf
end function

sub spielerinfo(byval wer as TypSpieler)
  info
  if Rundenzahl > 0 then
    info msg(MSG_rounds, str(Rundenzahl)), 5
  end if
  info wer.farbe, msg(MSG_turn, wer.name), 1
  Infozeile += 2
  info msg(MSG_info, wer.geld & MSG_currency, (wer.geld + wer.vermoegen) & MSG_currency, _
           wer.kredit & MSG_currency)
  if wer.feld < 253 then
    info msg(MSG_position, feld(wer.feld).name), 4
  else
    info msg(MSG_inJail, gefaengnis), 5
  end if
end sub

sub textausgabe(byref ort as TypGrafikfeld, byref text as string, byref farbe as integer = &hffffff)
  dim img as any pointer
  dim as string ausgabe = left(text, ort.b\8)
  img = imagecreate(ort.b, ort.h, 0)
  put (ort.x, ort.y), img, pset
  imagedestroy img
  draw string (ort.x+ort.b\2-4*len(ausgabe), ort.y+ort.h\2-4), ausgabe, farbe
end sub

sub verkaufen(byref wer as TypSpieler, byval wert as ushort = 0)
  dim akt as ubyte, maxhaus as byte, grup as TypGruppe
  mark Mverkauf
  do
    info
    info msg(MSG_money, wer.geld & MSG_currency)
    info MSG_clickToSell
    info MSG_pressESC
    put (buttonfeld_abbruch.x, buttonfeld_abbruch.y), button_abbruch.grafik, pset
    do
      akt = aktion(4)
      maxhaus = 0
      if akt > 0 and akt <= AnzahlFelder then
        if feld(akt).besitzer = wer.nr then
          grup = gruppe(feld(akt).gruppe)
          for i=0 to len(grup.grundstuecke)-1
            if feld(grup.grundstuecke[i]).besitzer <> wer.nr then continue for
            maxhaus = MAX(feld(grup.grundstuecke[i]).haeuser, maxhaus)
          next
          if maxhaus > 0 and feld(akt).haeuser = maxhaus then
            wer.geld += feld(akt).hauspreis\2
            wer.vermoegen -= feld(akt).hauspreis\2
            wer.belastbar -= feld(akt).hauspreis\2
            feld(akt).haeuser -= 1
            zeichne akt
            gesamtinfo
            elseif maxhaus = 0 and feld(akt).status = 0 then
            wer.geld += feld(akt).preis\2
            wer.vermoegen -= feld(akt).preis\2
            wer.belastbar -= feld(akt).preis\2
            feld(akt).status = 1
            zeichne akt
            gesamtinfo
          end if
        end if
      end if
    loop until akt > 0 or ende
  loop until akt = 204 or akt = 254 or (wert > 0 and wer.geld >= wert) or ende
  mark Mverkauf
  textausgabe buttonfeld_abbruch, ""
  spielerinfo wer
end sub

function wartetaste as string
  dim as integer mx, my, mb, m2x, m2y, m2b = 1
  dim as ubyte taste, aktinf = Infozeile
  for i as byte = aktinf to Ginfo.h\13 - 4 step -1
    info " "
  next
  put (buttonfeld_ok.x, buttonfeld_ok.y), button_ok.grafik, pset
  do : loop until inkey = ""
  do
    taste = aktion(3)
  loop until taste > 0 or ende
  textausgabe buttonfeld_ok, ""
  return chr(taste)
end function

function werfen as TypWurf
  ' wuerfelt und gibt die einzelnen Augenzahlen zurueck
  dim as TypWurf ret
  dim as single t
  for i=1 to 10
    ret.w1 = int(rnd*6)+1
    ret.w2 = int(rnd*6)+1
    zeigewurf(ret.w1, ret.w2)
    t = timer
    sleep 100
  next
  if _DEBUG = 1 then
    info "zwei Augenzahlen eingeben ..."
    ret.w1 = val(input(1)) : ret.w2 = val(input(1)) : zeigewurf(ret.w1, ret.w2)
  end if
  return ret
end function

sub zeichne(byval wert as ubyte = 0)
  ' Zeichnet das Spielfeld.
  ' wert = 0:Grundgeruest; >0:Einzelfeld
  dim as string dstring, status
  dim as single normb = Gspielfeld.b / (AnzahlFelder/4 + 2), normh = Gspielfeld.h / (AnzahlFelder/4 + 2)
  dim as ushort besitz
  dim as uinteger schriftfarbe
  if wert=0 then
    cls
    line (Gspielfeld.x, Gspielfeld.y)-step (Gspielfeld.b, Gspielfeld.h),&hffffff,B
    put (Gmenu.x, Gmenu.y), menuleiste.grafik, pset
    line (Gnachricht.x, Gnachricht.y)-step (Gnachricht.b, Gnachricht.h),&hffffff,B
    line (Gspielfeld.x+1, Gspielfeld.y+1)-step (Gspielfeld.b-2, Gspielfeld.h-2),0,BF
    for i=1 to AnzahlFelder
      zeichne i
    next
  else
    with feld(wert)
    besitz = MIN(.statusleiste.b,.statusleiste.h)
    line (.position.x+1, .position.y+1)-step(.position.b-2, .position.h-2), .hg_rgb, BF
    line (.statusleiste.x+1, .statusleiste.y+1)-step(.statusleiste.b-2, .statusleiste.h-2), .farb_rgb, BF
    line (.position.x, .position.y)-step(.position.b, .position.h),0,B
    if .besitzer > 0 then
      if (spieler(.besitzer).farbe and &hff0000)/&h10000 + (spieler(.besitzer).farbe _
        and &h00ff00)/&h100 + (spieler(.besitzer).farbe and &hff) < 384 then
        schriftfarbe = &hffffff
      else
        schriftfarbe = 0
      end if
      line (.statusleiste.x+2, .statusleiste.y+2)-step(besitz-4, besitz-4), spieler(.besitzer).farbe ,BF
    end if
    status = ""
    if .besitzer = 0 and .art = 1 then
      status = "$"
      elseif .haeuser > 0 then
      status = str(.haeuser)
      elseif .status <> 0 then
      status = "X"
      mark .position, &h333333
    end if
    draw string (.statusleiste.x+besitz/2-3, .statusleiste.y+besitz/2-3), status, schriftfarbe
    dim as ubyte spielerhier=0, radius=Gspielfeld.b/(AnzahlFelder/4+2)/4, xplus, yplus, abstand=radius/5+1
    if .position.x = .statusleiste.x and .position.b>.position.h then xplus = .statusleiste.b
    if .position.y = .statusleiste.y and .position.h>.position.b then yplus = .statusleiste.h
    if .icon.x > 1 then put (.position.x+.position.b/2-.icon.x/2, _
                             .position.y+.position.h/2-.icon.y/2), .icon.grafik, pset
    for k=1 to 20
      if spieler(k).feld = wert and spieler(k).typ > 0 then
        spielerhier += 1
        if spielerhier > 5 then exit for
        circle (.position.x+radius+spielerhier*abstand+xplus, _
                .position.y+radius+spielerhier*abstand+yplus), radius-1, spieler(k).farbe,,,, F
      end if
    next
    end with
  end if
end sub

sub zeigewurf(byval w1 as ubyte, byval w2 as ubyte)
  ' Zeigt Wuerfelwurf an (wird von werfen() aufgerufen)
  'Anzeige Wuerfel 1
  put (Ginfo.x+57, Ginfo.y+47), wuerfelseite.grafik, pset
  if w1 mod 2 then put (Ginfo.x+75, Ginfo.y+65), wuerfelauge.grafik, pset
  if w1 > 1 then
    put (Ginfo.x+90, Ginfo.y+50), wuerfelauge.grafik, pset
    put (Ginfo.x+60, Ginfo.y+80), wuerfelauge.grafik, pset
  end if
  if w1 > 3 then
    put (Ginfo.x+60, Ginfo.y+50), wuerfelauge.grafik, pset
    put (Ginfo.x+90, Ginfo.y+80), wuerfelauge.grafik, pset
  end if
  if w1 = 6 then
    put (Ginfo.x+60, Ginfo.y+65), wuerfelauge.grafik, pset
    put (Ginfo.x+90, Ginfo.y+65), wuerfelauge.grafik, pset
  end if
  'Anzeige Wuerfel 2
  put (Ginfo.x+Ginfo.b-108, Ginfo.y+47), wuerfelseite.grafik, pset
  if w2 mod 2 then put (Ginfo.x+Ginfo.b-90, Ginfo.y+65), wuerfelauge.grafik, pset
  if w2 > 1 then
    put (Ginfo.x+Ginfo.b-75, Ginfo.y+50), wuerfelauge.grafik, pset
    put (Ginfo.x+Ginfo.b-105, Ginfo.y+80), wuerfelauge.grafik, pset
  end if
  if w2 > 3 then
    put (Ginfo.x+Ginfo.b-105, Ginfo.y+50), wuerfelauge.grafik, pset
    put (Ginfo.x+Ginfo.b-75, Ginfo.y+80), wuerfelauge.grafik, pset
  end if
  if w2 = 6 then
    put (Ginfo.x+Ginfo.b-75, Ginfo.y+65), wuerfelauge.grafik, pset
    put (Ginfo.x+Ginfo.b-105, Ginfo.y+65), wuerfelauge.grafik, pset
  end if
end sub
